package com.yc.ship.module.resource.service.site;


import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.resource.controller.admin.site.vo.ScenicSitePageReqVO;
import com.yc.ship.module.resource.controller.admin.site.vo.ScenicSiteSaveReqVO;
import com.yc.ship.module.resource.dal.dataobject.site.ScenicSiteDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 站点 Service 接口
 *
 * @author 管理员
 */
public interface ScenicSiteService {

    /**
     * 创建站点
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createScenicSite(@Valid ScenicSiteSaveReqVO createReqVO);

    /**
     * 更新站点
     *
     * @param updateReqVO 更新信息
     */
    void updateScenicSite(@Valid ScenicSiteSaveReqVO updateReqVO);

    /**
     * 删除站点
     *
     * @param id 编号
     */
    void deleteScenicSite(Long id);

    /**
     * 获得站点
     *
     * @param id 编号
     * @return 站点
     */
    ScenicSiteDO getScenicSite(Long id);

    /**
     * 获得站点分页
     *
     * @param pageReqVO 分页查询
     * @return 站点分页
     */
    PageResult<ScenicSiteDO> getScenicSitePage(ScenicSitePageReqVO pageReqVO);

    List<ScenicSiteDO> getSiteListByStatus(Integer siteType);

    /**
     * 获得站点列表
     *
     * @param ids 站点编号数组
     * @return 站点列表
     */
    List<ScenicSiteDO> getSiteList(Collection<Long> ids);

    Map<Long, ScenicSiteDO> getSiteMap(Collection<Long> ids);
}
